# Human GSVA analysis



########################################################################
###### Environment #####################################################
########################################################################
## Package
lib <- readRDS("...zenodo/Others/library.rds")
for(i in 1: length(lib)){
  library(lib[i], character.only = T)
}

## Function
range01 <- function(x){(x-min(x))/(max(x)-min(x))}

########################################################################
###### Gene pseudotime correlation #####################################
########################################################################
Ind4 <- readRDS("...zenodo/Human_normal_breast_data/Ind4/Ind4_cleaned.rds")
Ind5 <- readRDS("...zenodo/Human_normal_breast_data/Ind5/Ind5_cleaned.rds")
Ind6 <- readRDS("...zenodo/Human_normal_breast_data/Ind6/Ind6_cleaned.rds")
Ind7 <- readRDS("...zenodo/Human_normal_breast_data/Ind7/Ind7_cleaned.rds")
meta <- read.csv("...zenodo/STREAM/Human_all_output/metadata_modified.csv",
                 row.names = 1)

##
Ind4 <- NormalizeData(Ind4)
Ind4 <- ScaleData(Ind4, features=rownames(Ind4))
matInd4 <- Ind4@assays$RNA@scale.data

Ind5 <- NormalizeData(Ind5)
Ind5 <- ScaleData(Ind5, features=rownames(Ind5))
matInd5 <- Ind5@assays$RNA@scale.data

Ind6 <- NormalizeData(Ind6)
Ind6 <- ScaleData(Ind6, features=rownames(Ind6))
matInd6 <- Ind6@assays$RNA@scale.data

Ind7 <- NormalizeData(Ind7)
Ind7 <- ScaleData(Ind7, features=rownames(Ind7))
matInd7 <- Ind7@assays$RNA@scale.data

remove(Ind5, Ind6, Ind4, Ind7)
gc();gc()


## 
matInd4 <- matInd4[,colnames(matInd4) %in% row.names(meta) ]
matInd5 <- matInd5[,colnames(matInd5) %in% row.names(meta) ]
matInd6 <- matInd6[,colnames(matInd6) %in% row.names(meta) ]
matInd7 <- matInd7[,colnames(matInd7) %in% row.names(meta) ]

meta <- meta[,6:10]
cor_data_Ind4 <- t(matInd4)
cor_data_Ind5 <- t(matInd5)
cor_data_Ind6 <- t(matInd6)
cor_data_Ind7 <- t(matInd7)

remove(matInd5, matInd4, matInd6, matInd7)
gc();gc()

# Ind4
meta_Ind4 <- meta[row.names(cor_data_Ind4),]
summary(row.names(meta_Ind4) == row.names(cor_data_Ind4))
cor_data_Ind4 <- cbind(meta_Ind4, cor_data_Ind4)
cor_data_Ind4 <- as.data.frame(cor_data_Ind4)

cor_Ind4_Stem <- cor(cor_data_Ind4$S3_pseudotime, 
                     cor_data_Ind4[,6:length(colnames(cor_data_Ind4))], method="s")
cor_Ind4_Basal <- cor(cor_data_Ind4$S4_pseudotime, 
                      cor_data_Ind4[,6:length(colnames(cor_data_Ind4))], method="s")
cor_Ind4_Alv <- cor(cor_data_Ind4$S2_pseudotime, 
                    cor_data_Ind4[,6:length(colnames(cor_data_Ind4))], method="s")
cor_Ind4_Hor <- cor(cor_data_Ind4$S1_pseudotime, 
                    cor_data_Ind4[,6:length(colnames(cor_data_Ind4))], method="s")
remove(cor_data_Ind4)
gc();gc()

# Ind5
meta_Ind5 <- meta[row.names(cor_data_Ind5),]
summary(row.names(meta_Ind5) == row.names(cor_data_Ind5))
cor_data_Ind5 <- cbind(meta_Ind5, cor_data_Ind5)
cor_data_Ind5 <- as.data.frame(cor_data_Ind5)

cor_Ind5_Stem <- cor(cor_data_Ind5$S3_pseudotime, 
                     cor_data_Ind5[,6:length(colnames(cor_data_Ind5))], method="s")
cor_Ind5_Basal <- cor(cor_data_Ind5$S4_pseudotime, 
                      cor_data_Ind5[,6:length(colnames(cor_data_Ind5))], method="s")
cor_Ind5_Alv <- cor(cor_data_Ind5$S2_pseudotime, 
                    cor_data_Ind5[,6:length(colnames(cor_data_Ind5))], method="s")
cor_Ind5_Hor <- cor(cor_data_Ind5$S1_pseudotime, 
                    cor_data_Ind5[,6:length(colnames(cor_data_Ind5))], method="s")
remove(cor_data_Ind5)
gc();gc()


# Ind6
meta_Ind6 <- meta[row.names(cor_data_Ind6),]
summary(row.names(meta_Ind6) == row.names(cor_data_Ind6))
cor_data_Ind6 <- cbind(meta_Ind6, cor_data_Ind6)
cor_data_Ind6 <- as.data.frame(cor_data_Ind6)

cor_Ind6_Stem <- cor(cor_data_Ind6$S3_pseudotime, 
                     cor_data_Ind6[,6:length(colnames(cor_data_Ind6))], method="s")
cor_Ind6_Basal <- cor(cor_data_Ind6$S4_pseudotime, 
                      cor_data_Ind6[,6:length(colnames(cor_data_Ind6))], method="s")
cor_Ind6_Alv <- cor(cor_data_Ind6$S2_pseudotime, 
                    cor_data_Ind6[,6:length(colnames(cor_data_Ind6))], method="s")
cor_Ind6_Hor <- cor(cor_data_Ind6$S1_pseudotime, 
                    cor_data_Ind6[,6:length(colnames(cor_data_Ind6))], method="s")
remove(cor_data_Ind6)
gc();gc()

# Ind7
meta_Ind7 <- meta[row.names(cor_data_Ind7),]
summary(row.names(meta_Ind7) == row.names(cor_data_Ind7))
cor_data_Ind7 <- cbind(meta_Ind7, cor_data_Ind7)
cor_data_Ind7 <- as.data.frame(cor_data_Ind7)

cor_Ind7_Stem <- cor(cor_data_Ind7$S3_pseudotime, 
                     cor_data_Ind7[,6:length(colnames(cor_data_Ind7))], method="s")
cor_Ind7_Basal <- cor(cor_data_Ind7$S4_pseudotime, 
                      cor_data_Ind7[,6:length(colnames(cor_data_Ind7))], method="s")
cor_Ind7_Alv <- cor(cor_data_Ind7$S2_pseudotime, 
                    cor_data_Ind7[,6:length(colnames(cor_data_Ind7))], method="s")
cor_Ind7_Hor <- cor(cor_data_Ind7$S1_pseudotime, 
                    cor_data_Ind7[,6:length(colnames(cor_data_Ind7))], method="s")
remove(cor_data_Ind7)
gc();gc()


##
temp <- list(cor_Ind4_Stem, cor_Ind4_Basal, cor_Ind4_Alv, cor_Ind4_Hor,
             cor_Ind5_Stem, cor_Ind5_Basal, cor_Ind5_Alv, cor_Ind5_Hor,
             cor_Ind6_Stem, cor_Ind6_Basal, cor_Ind6_Alv, cor_Ind6_Hor,
             cor_Ind7_Stem, cor_Ind7_Basal, cor_Ind7_Alv, cor_Ind7_Hor)
names(temp)<- c("cor_Ind4_Stem", "cor_Ind4_Basal", "cor_Ind4_Alv", "cor_Ind4_Hor",
                "cor_Ind5_Stem", 'cor_Ind5_Basal', "cor_Ind5_Alv", "cor_Ind5_Hor",
                "cor_Ind6_Stem", "cor_Ind6_Basal", "cor_Ind6_Alv", "cor_Ind6_Hor",
                "cor_Ind7_Stem", "cor_Ind7_Basal", "cor_Ind7_Alv", "cor_Ind7_Hor")


# Stem
cor_Ind4_Stem <- temp$cor_Ind4_Stem
cor_Ind4_Stem <- t(cor_Ind4_Stem)
colnames(cor_Ind4_Stem) <- "cor_Ind4"
cor_Ind4_Stem <- as.data.frame(cor_Ind4_Stem)
cor_Ind4_Stem$gene <- row.names(cor_Ind4_Stem)

cor_Ind5_Stem <- temp$cor_Ind5_Stem
cor_Ind5_Stem <- t(cor_Ind5_Stem)
colnames(cor_Ind5_Stem) <- "cor_Ind5"
cor_Ind5_Stem <- as.data.frame(cor_Ind5_Stem)
cor_Ind5_Stem$gene <- row.names(cor_Ind5_Stem)

cor_Ind6_Stem <- temp$cor_Ind6_Stem
cor_Ind6_Stem <- t(cor_Ind6_Stem)
colnames(cor_Ind6_Stem) <- "cor_Ind6"
cor_Ind6_Stem <- as.data.frame(cor_Ind6_Stem)
cor_Ind6_Stem$gene <- row.names(cor_Ind6_Stem)

cor_Ind7_Stem <- temp$cor_Ind7_Stem
cor_Ind7_Stem <- t(cor_Ind7_Stem)
colnames(cor_Ind7_Stem) <- "cor_Ind7"
cor_Ind7_Stem <- as.data.frame(cor_Ind7_Stem)
cor_Ind7_Stem$gene <- row.names(cor_Ind7_Stem)

cor_Stem <- merge(cor_Ind4_Stem, cor_Ind5_Stem, by.x="gene", by.y = "gene")
cor_Stem <- merge(cor_Stem, cor_Ind6_Stem, by.x="gene", by.y = "gene")
cor_Stem <- merge(cor_Stem, cor_Ind7_Stem, by.x="gene", by.y = "gene")
row.names(cor_Stem) <- cor_Stem$gene
cor_Stem <- cor_Stem[,2:5]
mean <- apply(cor_Stem, 1, mean)
rank <- rank(mean)
mean.inv <- -1*mean
rank.inv <- rank(mean.inv)
cor_Stem <- cbind(cor_Stem, mean, rank, mean.inv, rank.inv)

#Basal
cor_Ind4_Basal <- temp$cor_Ind4_Basal
cor_Ind4_Basal <- t(cor_Ind4_Basal)
colnames(cor_Ind4_Basal) <- "cor_Ind4"
cor_Ind4_Basal <- as.data.frame(cor_Ind4_Basal)
cor_Ind4_Basal$gene <- row.names(cor_Ind4_Basal)

cor_Ind5_Basal <- temp$cor_Ind5_Basal
cor_Ind5_Basal <- t(cor_Ind5_Basal)
colnames(cor_Ind5_Basal) <- "cor_Ind5"
cor_Ind5_Basal <- as.data.frame(cor_Ind5_Basal)
cor_Ind5_Basal$gene <- row.names(cor_Ind5_Basal)

cor_Ind6_Basal <- temp$cor_Ind6_Basal
cor_Ind6_Basal <- t(cor_Ind6_Basal)
colnames(cor_Ind6_Basal) <- "cor_Ind6"
cor_Ind6_Basal <- as.data.frame(cor_Ind6_Basal)
cor_Ind6_Basal$gene <- row.names(cor_Ind6_Basal)

cor_Ind7_Basal <- temp$cor_Ind7_Basal
cor_Ind7_Basal <- t(cor_Ind7_Basal)
colnames(cor_Ind7_Basal) <- "cor_Ind7"
cor_Ind7_Basal <- as.data.frame(cor_Ind7_Basal)
cor_Ind7_Basal$gene <- row.names(cor_Ind7_Basal)

cor_Basal <- merge(cor_Ind4_Basal, cor_Ind5_Basal, by.x="gene", by.y = "gene")
cor_Basal <- merge(cor_Basal, cor_Ind6_Basal, by.x="gene", by.y = "gene")
cor_Basal <- merge(cor_Basal, cor_Ind7_Basal, by.x="gene", by.y = "gene")
row.names(cor_Basal) <- cor_Basal$gene
cor_Basal <- cor_Basal[,2:5]
mean <- apply(cor_Basal, 1, mean)
rank <- rank(mean)
mean.inv <- -1*mean
rank.inv <- rank(mean.inv)
cor_Basal <- cbind(cor_Basal, mean, rank, mean.inv, rank.inv)

#Alv
cor_Ind4_Alv <- temp$cor_Ind4_Alv
cor_Ind4_Alv <- t(cor_Ind4_Alv)
colnames(cor_Ind4_Alv) <- "cor_Ind4"
cor_Ind4_Alv <- as.data.frame(cor_Ind4_Alv)
cor_Ind4_Alv$gene <- row.names(cor_Ind4_Alv)

cor_Ind5_Alv <- temp$cor_Ind5_Alv
cor_Ind5_Alv <- t(cor_Ind5_Alv)
colnames(cor_Ind5_Alv) <- "cor_Ind5"
cor_Ind5_Alv <- as.data.frame(cor_Ind5_Alv)
cor_Ind5_Alv$gene <- row.names(cor_Ind5_Alv)

cor_Ind6_Alv <- temp$cor_Ind6_Alv
cor_Ind6_Alv <- t(cor_Ind6_Alv)
colnames(cor_Ind6_Alv) <- "cor_Ind6"
cor_Ind6_Alv <- as.data.frame(cor_Ind6_Alv)
cor_Ind6_Alv$gene <- row.names(cor_Ind6_Alv)

cor_Ind7_Alv <- temp$cor_Ind7_Alv
cor_Ind7_Alv <- t(cor_Ind7_Alv)
colnames(cor_Ind7_Alv) <- "cor_Ind7"
cor_Ind7_Alv <- as.data.frame(cor_Ind7_Alv)
cor_Ind7_Alv$gene <- row.names(cor_Ind7_Alv)

cor_Alv <- merge(cor_Ind4_Alv, cor_Ind5_Alv, by.x="gene", by.y = "gene")
cor_Alv <- merge(cor_Alv, cor_Ind6_Alv, by.x="gene", by.y = "gene")
cor_Alv <- merge(cor_Alv, cor_Ind7_Alv, by.x="gene", by.y = "gene")
row.names(cor_Alv) <- cor_Alv$gene
cor_Alv <- cor_Alv[,2:5]
mean <- apply(cor_Alv, 1, mean)
rank <- rank(mean)
mean.inv <- -1*mean
rank.inv <- rank(mean.inv)
cor_Alv <- cbind(cor_Alv, mean, rank, mean.inv, rank.inv)

#Hor
cor_Ind4_Hor <- temp$cor_Ind4_Hor
cor_Ind4_Hor <- t(cor_Ind4_Hor)
colnames(cor_Ind4_Hor) <- "cor_Ind4"
cor_Ind4_Hor <- as.data.frame(cor_Ind4_Hor)
cor_Ind4_Hor$gene <- row.names(cor_Ind4_Hor)

cor_Ind5_Hor <- temp$cor_Ind5_Hor
cor_Ind5_Hor <- t(cor_Ind5_Hor)
colnames(cor_Ind5_Hor) <- "cor_Ind5"
cor_Ind5_Hor <- as.data.frame(cor_Ind5_Hor)
cor_Ind5_Hor$gene <- row.names(cor_Ind5_Hor)

cor_Ind6_Hor <- temp$cor_Ind6_Hor
cor_Ind6_Hor <- t(cor_Ind6_Hor)
colnames(cor_Ind6_Hor) <- "cor_Ind6"
cor_Ind6_Hor <- as.data.frame(cor_Ind6_Hor)
cor_Ind6_Hor$gene <- row.names(cor_Ind6_Hor)

cor_Ind7_Hor <- temp$cor_Ind7_Hor
cor_Ind7_Hor <- t(cor_Ind7_Hor)
colnames(cor_Ind7_Hor) <- "cor_Ind7"
cor_Ind7_Hor <- as.data.frame(cor_Ind7_Hor)
cor_Ind7_Hor$gene <- row.names(cor_Ind7_Hor)

cor_Hor <- merge(cor_Ind4_Hor, cor_Ind5_Hor, by.x="gene", by.y = "gene")
cor_Hor <- merge(cor_Hor, cor_Ind6_Hor, by.x="gene", by.y = "gene")
cor_Hor <- merge(cor_Hor, cor_Ind7_Hor, by.x="gene", by.y = "gene")
row.names(cor_Hor) <- cor_Hor$gene
cor_Hor <- cor_Hor[,2:5]
mean <- apply(cor_Hor, 1, mean)
rank <- rank(mean)
mean.inv <- -1*mean
rank.inv <- rank(mean.inv)
cor_Hor <- cbind(cor_Hor, mean, rank, mean.inv, rank.inv)

# Data saving
write.csv(cor_Stem, "...zenodo/GSVA/Human/cor_Stem.csv")
write.csv(cor_Alv, "...zenodo/GSVA/Human/cor_Alv.csv")
write.csv(cor_Basal, "...zenodo/GSVA/Human/cor_Basal.csv")
write.csv(cor_Hor, "...zenodo/GSVA/Human/cor_Hor.csv")



##########################################################################
############# Top gene lists #############################################
##########################################################################
cor_Stem <- read.csv("...zenodo/GSVA/Human/cor_Stem.csv")
cor_Alv <- read.csv("...zenodo/GSVA/Human/cor_Alv.csv")
cor_Basal <- read.csv("...zenodo/GSVA/Human/cor_Basal.csv")
cor_Hor <-  read.csv("...zenodo/GSVA/Human/cor_Hor.csv")

#Stem
colnames(cor_Stem)[1] <- "gene"
cor_Stem <- cor_Stem %>% arrange(rank)
hoge <- list()
for(i in 1:100){
  y <- list(as.character(cor_Stem$gene[1:i]))
  names(y) <- paste("Top_Stem", i, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Stem_cor_genes_top100.rds")

#Basal
colnames(cor_Basal)[1] <- "gene"
cor_Basal <- cor_Basal %>% arrange(rank)
hoge <- list()
for(i in 1:100){
  y <- list(as.character(cor_Basal$gene[1:i]))
  names(y) <- paste("Top_Basal", i, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Basal_cor_genes_top100.rds")

#Alv
colnames(cor_Alv)[1] <- "gene"
cor_Alv <- cor_Alv %>% arrange(rank)
hoge <- list()
for(i in 1:100){
  y <- list(as.character(cor_Alv$gene[1:i]))
  names(y) <- paste("Top_Alv", i, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Alv_cor_genes_top100.rds")

#Hor
colnames(cor_Hor)[1] <- "gene"
cor_Hor <- cor_Hor %>% arrange(rank)
hoge <- list()
for(i in 1:100){
  y <- list(as.character(cor_Hor$gene[1:i]))
  names(y) <- paste("Top_Hor", i, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Hor_cor_genes_top100.rds")



##########################################################################
############# Top gene lists 2 ###########################################
##########################################################################
cor_Stem <- read.csv("...zenodo/GSVA/Human/cor_Stem.csv")
cor_Alv <- read.csv("...zenodo/GSVA/Human/cor_Alv.csv")
cor_Basal <- read.csv("...zenodo/GSVA/Human/cor_Basal.csv")
cor_Hor <-  read.csv("...zenodo/GSVA/Human/cor_Hor.csv")

#Stem
colnames(cor_Stem)[1] <- "gene"
cor_Stem <- cor_Stem %>% arrange(rank)
hoge <- list()
for(i in 1:45){
  x <- 100+20*i
  y <- list(as.character(cor_Stem$gene[1:x]))
  names(y) <- paste("Top_Stem", x, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Stem_cor_genes_top1000.rds")

#Basal
colnames(cor_Basal)[1] <- "gene"
cor_Basal <- cor_Basal %>% arrange(rank)
hoge <- list()
for(i in 1:45){
  x <- 100+20*i
  y <- list(as.character(cor_Basal$gene[1:x]))
  names(y) <- paste("Top_Basal", x, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Basal_cor_genes_top1000.rds")

#Alv
colnames(cor_Alv)[1] <- "gene"
cor_Alv <- cor_Alv %>% arrange(rank)
hoge <- list()
for(i in 1:45){
  x <- 100+20*i
  y <- list(as.character(cor_Alv$gene[1:x]))
  names(y) <- paste("Top_Alv", x, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Alv_cor_genes_top1000.rds")

#Hor
colnames(cor_Hor)[1] <- "gene"
cor_Hor <- cor_Hor %>% arrange(rank)
hoge <- list()
for(i in 1:45){
  x <- 100+20*i
  y <- list(as.character(cor_Hor$gene[1:x]))
  names(y) <- paste("Top_Hor", x, sep = "_")
  hoge <- c(hoge, y)
}
saveRDS(hoge, "...zenodo/GSVA/Human/Hor_cor_genes_top1000.rds")



##########################################################################
############ GSVA analysis for gene list performance evaluation ##########
##########################################################################
# Data_prep
Ind4 <- readRDS("...zenodo/Human_normal_breast_data/Ind4/Ind4_cleaned.rds")
Ind5 <- readRDS("...zenodo/Human_normal_breast_data/Ind5/Ind5_cleaned.rds")
Ind6 <- readRDS("...zenodo/Human_normal_breast_data/Ind6/Ind6_cleaned.rds")
Ind7 <- readRDS("...zenodo/Human_normal_breast_data/Ind7/Ind7_cleaned.rds")
meta <- read.csv("...zenodo/STREAM/Human_all_output/metadata_modified.csv",
                 row.names = 1)
Cell_barcodes <- readRDS("...zenodo/STREAM/Human_cells_STREAM.rds")


#
Ind4 <- NormalizeData(Ind4)
Ind4 <- ScaleData(Ind4, features=rownames(Ind4))
matInd4 <- Ind4@assays$RNA@scale.data

Ind5 <- NormalizeData(Ind5)
Ind5 <- ScaleData(Ind5, features=rownames(Ind5))
matInd5 <- Ind5@assays$RNA@scale.data

Ind6 <- NormalizeData(Ind6)
Ind6 <- ScaleData(Ind6, features=rownames(Ind6))
matInd6 <- Ind6@assays$RNA@scale.data

Ind7 <- NormalizeData(Ind7)
Ind7 <- ScaleData(Ind7, features=rownames(Ind7))
matInd7 <- Ind7@assays$RNA@scale.data

matInd4 <- matInd4[,colnames(matInd4) %in% Cell_barcodes ]
matInd5 <- matInd5[,colnames(matInd5) %in% Cell_barcodes ]
matInd6 <- matInd6[,colnames(matInd6) %in% Cell_barcodes ]
matInd7 <- matInd7[,colnames(matInd7) %in% Cell_barcodes ]

#
meta_Ind4 <- meta[colnames(matInd4),]
meta_Ind5 <- meta[colnames(matInd5),]
meta_Ind6 <- meta[colnames(matInd6),]
meta_Ind7 <- meta[colnames(matInd7),]

remove(Ind5, Ind6, Ind4, Ind7, Cell_barcodes)
gc();gc()

# Stem
Stem_gene_sets <- readRDS("...zenodo/GSVA/Human/Stem_cor_genes_top100.rds")
#
Ind4_gsvaResult_Stem <- gsva(matInd4, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind4_GSVA_Stem_100.csv")
Ind4_gsvaResult_Stem <- t(Ind4_gsvaResult_Stem)
Ind4_gsvaResult_Stem <- cbind(meta_Ind4$S3_pseudotime, Ind4_gsvaResult_Stem)
cor_Ind4_GSVA_Stem <- cor(Ind4_gsvaResult_Stem[,1], Ind4_gsvaResult_Stem[,2:101], method="s")
cor_GSVA_Stem <- NULL
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind4_GSVA_Stem)
#
Ind5_gsvaResult_Stem <- gsva(matInd5, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind5_GSVA_Stem_100.csv")
Ind5_gsvaResult_Stem <- t(Ind5_gsvaResult_Stem)
Ind5_gsvaResult_Stem <- cbind(meta_Ind5$S3_pseudotime, Ind5_gsvaResult_Stem)
cor_Ind5_GSVA_Stem <- cor(Ind5_gsvaResult_Stem[,1], Ind5_gsvaResult_Stem[,2:101], method="s")
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind5_GSVA_Stem)
#
Ind6_gsvaResult_Stem <- gsva(matInd6, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind6_GSVA_Stem_100.csv")
Ind6_gsvaResult_Stem <- t(Ind6_gsvaResult_Stem)
Ind6_gsvaResult_Stem <- cbind(meta_Ind6$S3_pseudotime, Ind6_gsvaResult_Stem)
cor_Ind6_GSVA_Stem <- cor(Ind6_gsvaResult_Stem[,1], Ind6_gsvaResult_Stem[,2:101], method="s")
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind6_GSVA_Stem)
#
Ind7_gsvaResult_Stem <- gsva(matInd7, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind7_GSVA_Stem_100.csv")
Ind7_gsvaResult_Stem <- t(Ind7_gsvaResult_Stem)
Ind7_gsvaResult_Stem <- cbind(meta_Ind7$S3_pseudotime, Ind7_gsvaResult_Stem)
cor_Ind7_GSVA_Stem <- cor(Ind7_gsvaResult_Stem[,1], Ind7_gsvaResult_Stem[,2:101], method="s")
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind7_GSVA_Stem)


# Basal
Basal_gene_sets <- readRDS("...zenodo/GSVA/Human/Basal_cor_genes_top100.rds")
#
Ind4_gsvaResult_Basal <- gsva(matInd4, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind4_GSVA_Basal_100.csv")
Ind4_gsvaResult_Basal <- t(Ind4_gsvaResult_Basal)
Ind4_gsvaResult_Basal <- cbind(meta_Ind4$S4_pseudotime, Ind4_gsvaResult_Basal)
cor_Ind4_GSVA_Basal <- cor(Ind4_gsvaResult_Basal[,1], Ind4_gsvaResult_Basal[,2:101], method="s")
cor_GSVA_Basal <- NULL
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind4_GSVA_Basal)
#
Ind5_gsvaResult_Basal <- gsva(matInd5, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind5_GSVA_Basal_100.csv")
Ind5_gsvaResult_Basal <- t(Ind5_gsvaResult_Basal)
Ind5_gsvaResult_Basal <- cbind(meta_Ind5$S4_pseudotime, Ind5_gsvaResult_Basal)
cor_Ind5_GSVA_Basal <- cor(Ind5_gsvaResult_Basal[,1], Ind5_gsvaResult_Basal[,2:101], method="s")
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind5_GSVA_Basal)
#
Ind6_gsvaResult_Basal <- gsva(matInd6, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind6_GSVA_Basal_100.csv")
Ind6_gsvaResult_Basal <- t(Ind6_gsvaResult_Basal)
Ind6_gsvaResult_Basal <- cbind(meta_Ind6$S4_pseudotime, Ind6_gsvaResult_Basal)
cor_Ind6_GSVA_Basal <- cor(Ind6_gsvaResult_Basal[,1], Ind6_gsvaResult_Basal[,2:101], method="s")
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind6_GSVA_Basal)
#
Ind7_gsvaResult_Basal <- gsva(matInd7, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind7_GSVA_Basal_100.csv")
Ind7_gsvaResult_Basal <- t(Ind7_gsvaResult_Basal)
Ind7_gsvaResult_Basal <- cbind(meta_Ind7$S4_pseudotime, Ind7_gsvaResult_Basal)
cor_Ind7_GSVA_Basal <- cor(Ind7_gsvaResult_Basal[,1], Ind7_gsvaResult_Basal[,2:101], method="s")
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind7_GSVA_Basal)


# Alv
Alv_gene_sets <- readRDS("...zenodo/GSVA/Human/Alv_cor_genes_top100.rds")
#
Ind4_gsvaResult_Alv <- gsva(matInd4, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind4_GSVA_Alv_100.csv")
Ind4_gsvaResult_Alv <- t(Ind4_gsvaResult_Alv)
Ind4_gsvaResult_Alv <- cbind(meta_Ind4$S2_pseudotime, Ind4_gsvaResult_Alv)
cor_Ind4_GSVA_Alv <- cor(Ind4_gsvaResult_Alv[,1], Ind4_gsvaResult_Alv[,2:101], method="s")
cor_GSVA_Alv <- NULL
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind4_GSVA_Alv)
#
Ind5_gsvaResult_Alv <- gsva(matInd5, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind5_GSVA_Alv_100.csv")
Ind5_gsvaResult_Alv <- t(Ind5_gsvaResult_Alv)
Ind5_gsvaResult_Alv <- cbind(meta_Ind5$S2_pseudotime, Ind5_gsvaResult_Alv)
cor_Ind5_GSVA_Alv <- cor(Ind5_gsvaResult_Alv[,1], Ind5_gsvaResult_Alv[,2:101], method="s")
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind5_GSVA_Alv)
#
Ind6_gsvaResult_Alv <- gsva(matInd6, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind6_GSVA_Alv_100.csv")
Ind6_gsvaResult_Alv <- t(Ind6_gsvaResult_Alv)
Ind6_gsvaResult_Alv <- cbind(meta_Ind6$S2_pseudotime, Ind6_gsvaResult_Alv)
cor_Ind6_GSVA_Alv <- cor(Ind6_gsvaResult_Alv[,1], Ind6_gsvaResult_Alv[,2:101], method="s")
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind6_GSVA_Alv)
#
Ind7_gsvaResult_Alv <- gsva(matInd7, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind7_GSVA_Alv_100.csv")
Ind7_gsvaResult_Alv <- t(Ind7_gsvaResult_Alv)
Ind7_gsvaResult_Alv <- cbind(meta_Ind7$S2_pseudotime, Ind7_gsvaResult_Alv)
cor_Ind7_GSVA_Alv <- cor(Ind7_gsvaResult_Alv[,1], Ind7_gsvaResult_Alv[,2:101], method="s")
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind7_GSVA_Alv)


# Hor
Hor_gene_sets <- readRDS("...zenodo/GSVA/Human/Hor_cor_genes_top100.rds")
#
Ind4_gsvaResult_Hor <- gsva(matInd4, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind4_GSVA_Hor_100.csv")
Ind4_gsvaResult_Hor <- t(Ind4_gsvaResult_Hor)
Ind4_gsvaResult_Hor <- cbind(meta_Ind4$S1_pseudotime, Ind4_gsvaResult_Hor)
cor_Ind4_GSVA_Hor <- cor(Ind4_gsvaResult_Hor[,1], Ind4_gsvaResult_Hor[,2:101], method="s")
cor_GSVA_Hor <- NULL
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind4_GSVA_Hor)
#
Ind5_gsvaResult_Hor <- gsva(matInd5, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind5_GSVA_Hor_100.csv")
Ind5_gsvaResult_Hor <- t(Ind5_gsvaResult_Hor)
Ind5_gsvaResult_Hor <- cbind(meta_Ind5$S1_pseudotime, Ind5_gsvaResult_Hor)
cor_Ind5_GSVA_Hor <- cor(Ind5_gsvaResult_Hor[,1], Ind5_gsvaResult_Hor[,2:101], method="s")
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind5_GSVA_Hor)
#
Ind6_gsvaResult_Hor <- gsva(matInd6, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind6_GSVA_Hor_100.csv")
Ind6_gsvaResult_Hor <- t(Ind6_gsvaResult_Hor)
Ind6_gsvaResult_Hor <- cbind(meta_Ind6$S1_pseudotime, Ind6_gsvaResult_Hor)
cor_Ind6_GSVA_Hor <- cor(Ind6_gsvaResult_Hor[,1], Ind6_gsvaResult_Hor[,2:101], method="s")
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind6_GSVA_Hor)
#
Ind7_gsvaResult_Hor <- gsva(matInd7, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind7_GSVA_Hor_100.csv")
Ind7_gsvaResult_Hor <- t(Ind7_gsvaResult_Hor)
Ind7_gsvaResult_Hor <- cbind(meta_Ind7$S1_pseudotime, Ind7_gsvaResult_Hor)
cor_Ind7_GSVA_Hor <- cor(Ind7_gsvaResult_Hor[,1], Ind7_gsvaResult_Hor[,2:101], method="s")
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind7_GSVA_Hor)

rownames(cor_GSVA_Stem) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Stem, "...zenodo/GSVA/Human/cor_GSVA_Stem.csv")
rownames(cor_GSVA_Basal) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Basal, "...zenodo/GSVA/Human/cor_GSVA_Basal.csv")
rownames(cor_GSVA_Alv) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Alv, "...zenodo/GSVA/Human/cor_GSVA_Alv.csv")
rownames(cor_GSVA_Hor) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Hor, "...zenodo/GSVA/Human/cor_GSVA_Hor.csv")




##########################################################################
############ GSVA analysis for gene list performance evaluation 2 ########
##########################################################################
# Stem
Stem_gene_sets <- readRDS("...zenodo/GSVA/Human/Stem_cor_genes_top1000.rds")
#
Ind4_gsvaResult_Stem <- gsva(matInd4, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind4_GSVA_Stem_1000.csv")
Ind4_gsvaResult_Stem <- t(Ind4_gsvaResult_Stem)
Ind4_gsvaResult_Stem <- cbind(meta_Ind4$S3_pseudotime, Ind4_gsvaResult_Stem)
cor_Ind4_GSVA_Stem <- cor(Ind4_gsvaResult_Stem[,1], Ind4_gsvaResult_Stem[,2:46], method="s")
cor_GSVA_Stem <- NULL
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind4_GSVA_Stem)
#
Ind5_gsvaResult_Stem <- gsva(matInd5, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind5_GSVA_Stem_1000.csv")
Ind5_gsvaResult_Stem <- t(Ind5_gsvaResult_Stem)
Ind5_gsvaResult_Stem <- cbind(meta_Ind5$S3_pseudotime, Ind5_gsvaResult_Stem)
cor_Ind5_GSVA_Stem <- cor(Ind5_gsvaResult_Stem[,1], Ind5_gsvaResult_Stem[,2:46], method="s")
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind5_GSVA_Stem)
#
Ind6_gsvaResult_Stem <- gsva(matInd6, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind6_GSVA_Stem_1000.csv")
Ind6_gsvaResult_Stem <- t(Ind6_gsvaResult_Stem)
Ind6_gsvaResult_Stem <- cbind(meta_Ind6$S3_pseudotime, Ind6_gsvaResult_Stem)
cor_Ind6_GSVA_Stem <- cor(Ind6_gsvaResult_Stem[,1], Ind6_gsvaResult_Stem[,2:46], method="s")
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind6_GSVA_Stem)
#
Ind7_gsvaResult_Stem <- gsva(matInd7, Stem_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Stem, "...zenodo/GSVA/Human/Ind7_GSVA_Stem_1000.csv")
Ind7_gsvaResult_Stem <- t(Ind7_gsvaResult_Stem)
Ind7_gsvaResult_Stem <- cbind(meta_Ind7$S3_pseudotime, Ind7_gsvaResult_Stem)
cor_Ind7_GSVA_Stem <- cor(Ind7_gsvaResult_Stem[,1], Ind7_gsvaResult_Stem[,2:46], method="s")
cor_GSVA_Stem <- rbind(cor_GSVA_Stem, cor_Ind7_GSVA_Stem)


# Basal
Basal_gene_sets <- readRDS("...zenodo/GSVA/Human/Basal_cor_genes_top1000.rds")
#
Ind4_gsvaResult_Basal <- gsva(matInd4, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind4_GSVA_Basal_1000.csv")
Ind4_gsvaResult_Basal <- t(Ind4_gsvaResult_Basal)
Ind4_gsvaResult_Basal <- cbind(meta_Ind4$S4_pseudotime, Ind4_gsvaResult_Basal)
cor_Ind4_GSVA_Basal <- cor(Ind4_gsvaResult_Basal[,1], Ind4_gsvaResult_Basal[,2:46], method="s")
cor_GSVA_Basal <- NULL
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind4_GSVA_Basal)
#
Ind5_gsvaResult_Basal <- gsva(matInd5, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind5_GSVA_Basal_1000.csv")
Ind5_gsvaResult_Basal <- t(Ind5_gsvaResult_Basal)
Ind5_gsvaResult_Basal <- cbind(meta_Ind5$S4_pseudotime, Ind5_gsvaResult_Basal)
cor_Ind5_GSVA_Basal <- cor(Ind5_gsvaResult_Basal[,1], Ind5_gsvaResult_Basal[,2:46], method="s")
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind5_GSVA_Basal)
#
Ind6_gsvaResult_Basal <- gsva(matInd6, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind6_GSVA_Basal_1000.csv")
Ind6_gsvaResult_Basal <- t(Ind6_gsvaResult_Basal)
Ind6_gsvaResult_Basal <- cbind(meta_Ind6$S4_pseudotime, Ind6_gsvaResult_Basal)
cor_Ind6_GSVA_Basal <- cor(Ind6_gsvaResult_Basal[,1], Ind6_gsvaResult_Basal[,2:46], method="s")
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind6_GSVA_Basal)
#
Ind7_gsvaResult_Basal <- gsva(matInd7, Basal_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Basal, "...zenodo/GSVA/Human/Ind7_GSVA_Basal_1000.csv")
Ind7_gsvaResult_Basal <- t(Ind7_gsvaResult_Basal)
Ind7_gsvaResult_Basal <- cbind(meta_Ind7$S4_pseudotime, Ind7_gsvaResult_Basal)
cor_Ind7_GSVA_Basal <- cor(Ind7_gsvaResult_Basal[,1], Ind7_gsvaResult_Basal[,2:46], method="s")
cor_GSVA_Basal <- rbind(cor_GSVA_Basal, cor_Ind7_GSVA_Basal)


# Alv
Alv_gene_sets <- readRDS("...zenodo/GSVA/Human/Alv_cor_genes_top1000.rds")
#
Ind4_gsvaResult_Alv <- gsva(matInd4, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind4_GSVA_Alv_1000.csv")
Ind4_gsvaResult_Alv <- t(Ind4_gsvaResult_Alv)
Ind4_gsvaResult_Alv <- cbind(meta_Ind4$S2_pseudotime, Ind4_gsvaResult_Alv)
cor_Ind4_GSVA_Alv <- cor(Ind4_gsvaResult_Alv[,1], Ind4_gsvaResult_Alv[,2:46], method="s")
cor_GSVA_Alv <- NULL
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind4_GSVA_Alv)
#
Ind5_gsvaResult_Alv <- gsva(matInd5, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind5_GSVA_Alv_1000.csv")
Ind5_gsvaResult_Alv <- t(Ind5_gsvaResult_Alv)
Ind5_gsvaResult_Alv <- cbind(meta_Ind5$S2_pseudotime, Ind5_gsvaResult_Alv)
cor_Ind5_GSVA_Alv <- cor(Ind5_gsvaResult_Alv[,1], Ind5_gsvaResult_Alv[,2:46], method="s")
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind5_GSVA_Alv)
#
Ind6_gsvaResult_Alv <- gsva(matInd6, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind6_GSVA_Alv_1000.csv")
Ind6_gsvaResult_Alv <- t(Ind6_gsvaResult_Alv)
Ind6_gsvaResult_Alv <- cbind(meta_Ind6$S2_pseudotime, Ind6_gsvaResult_Alv)
cor_Ind6_GSVA_Alv <- cor(Ind6_gsvaResult_Alv[,1], Ind6_gsvaResult_Alv[,2:46], method="s")
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind6_GSVA_Alv)
#
Ind7_gsvaResult_Alv <- gsva(matInd7, Alv_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Alv, "...zenodo/GSVA/Human/Ind7_GSVA_Alv_1000.csv")
Ind7_gsvaResult_Alv <- t(Ind7_gsvaResult_Alv)
Ind7_gsvaResult_Alv <- cbind(meta_Ind7$S2_pseudotime, Ind7_gsvaResult_Alv)
cor_Ind7_GSVA_Alv <- cor(Ind7_gsvaResult_Alv[,1], Ind7_gsvaResult_Alv[,2:46], method="s")
cor_GSVA_Alv <- rbind(cor_GSVA_Alv, cor_Ind7_GSVA_Alv)


# Hor
Hor_gene_sets <- readRDS("...zenodo/GSVA/Human/Hor_cor_genes_top1000.rds")
#
Ind4_gsvaResult_Hor <- gsva(matInd4, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind4_GSVA_Hor_1000.csv")
Ind4_gsvaResult_Hor <- t(Ind4_gsvaResult_Hor)
Ind4_gsvaResult_Hor <- cbind(meta_Ind4$S1_pseudotime, Ind4_gsvaResult_Hor)
cor_Ind4_GSVA_Hor <- cor(Ind4_gsvaResult_Hor[,1], Ind4_gsvaResult_Hor[,2:46], method="s")
cor_GSVA_Hor <- NULL
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind4_GSVA_Hor)
#
Ind5_gsvaResult_Hor <- gsva(matInd5, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind5_GSVA_Hor_1000.csv")
Ind5_gsvaResult_Hor <- t(Ind5_gsvaResult_Hor)
Ind5_gsvaResult_Hor <- cbind(meta_Ind5$S1_pseudotime, Ind5_gsvaResult_Hor)
cor_Ind5_GSVA_Hor <- cor(Ind5_gsvaResult_Hor[,1], Ind5_gsvaResult_Hor[,2:46], method="s")
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind5_GSVA_Hor)
#
Ind6_gsvaResult_Hor <- gsva(matInd6, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind6_GSVA_Hor_1000.csv")
Ind6_gsvaResult_Hor <- t(Ind6_gsvaResult_Hor)
Ind6_gsvaResult_Hor <- cbind(meta_Ind6$S1_pseudotime, Ind6_gsvaResult_Hor)
cor_Ind6_GSVA_Hor <- cor(Ind6_gsvaResult_Hor[,1], Ind6_gsvaResult_Hor[,2:46], method="s")
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind6_GSVA_Hor)
#
Ind7_gsvaResult_Hor <- gsva(matInd7, Hor_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult_Hor, "...zenodo/GSVA/Human/Ind7_GSVA_Hor_1000.csv")
Ind7_gsvaResult_Hor <- t(Ind7_gsvaResult_Hor)
Ind7_gsvaResult_Hor <- cbind(meta_Ind7$S1_pseudotime, Ind7_gsvaResult_Hor)
cor_Ind7_GSVA_Hor <- cor(Ind7_gsvaResult_Hor[,1], Ind7_gsvaResult_Hor[,2:46], method="s")
cor_GSVA_Hor <- rbind(cor_GSVA_Hor, cor_Ind7_GSVA_Hor)


###
rownames(cor_GSVA_Stem) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Stem, "...zenodo/GSVA/Human/cor_GSVA_Stem_1000.csv")
rownames(cor_GSVA_Basal) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Basal, "...zenodo/GSVA/Human/cor_GSVA_Basal_1000.csv")
rownames(cor_GSVA_Alv) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Alv, "...zenodo/GSVA/Human/cor_GSVA_Alv_1000.csv")
rownames(cor_GSVA_Hor) <- c("Ind4", "Ind5", "Ind6", "Ind7")
write.csv(cor_GSVA_Hor, "...zenodo/GSVA/Human/cor_GSVA_Hor_1000.csv")



##########################################################################
############ GSVA analysis for curated gene sets  #######################
##########################################################################
Stem_gene_sets <- readRDS("...zenodo/GSVA/Human/Stem_cor_genes_top100.rds")
Basal_gene_sets <- readRDS("...zenodo/GSVA/Human/Basal_cor_genes_top1000.rds")
Alv_gene_sets <- readRDS("...zenodo/GSVA/Human/Alv_cor_genes_top1000.rds")
Hor_gene_sets <- readRDS("...zenodo/GSVA/Human/Hor_cor_genes_top1000.rds")
Curated_gene_sets <- list(Stem_gene_sets$Top_Stem_100, Basal_gene_sets$Top_Basal_1000, Alv_gene_sets$Top_Alv_500, Hor_gene_sets$Top_Hor_240)
names(Curated_gene_sets) <- c("Curated_Stem", "Curated_Basal", "Curated_Alv", "Curated_Hor")
remove(Stem_gene_sets, Basal_gene_sets, Alv_gene_sets, Hor_gene_sets)
gc();gc()


# Data_prep
Ind4 <- readRDS("...zenodo/Human_normal_breast_data/Ind4/Ind4_cleaned.rds")
Ind5 <- readRDS("...zenodo/Human_normal_breast_data/Ind5/Ind5_cleaned.rds")
Ind6 <- readRDS("...zenodo/Human_normal_breast_data/Ind6/Ind6_cleaned.rds")
Ind7 <- readRDS("...zenodo/Human_normal_breast_data/Ind7/Ind7_cleaned.rds")
meta <- read.csv("...zenodo/STREAM/Human_all_output/metadata_modified.csv",
                 row.names = 1)
Nguyen <- readRDS("...zenodo/Human_normal_breast_data/Nguyen_integrated_cleaned.rds")
Cell_barcodes <-colnames(Nguyen)

#
Ind4 <- subset(Ind4, cells = colnames(Ind4)[colnames(Ind4) %in% Cell_barcodes])
Ind4 <- NormalizeData(Ind4)
Ind4 <- ScaleData(Ind4, features=rownames(Ind4))
matInd4 <- Ind4@assays$RNA@scale.data

Ind5 <- subset(Ind5, cells = colnames(Ind5)[colnames(Ind5) %in% Cell_barcodes])
Ind5 <- NormalizeData(Ind5)
Ind5 <- ScaleData(Ind5, features=rownames(Ind5))
matInd5 <- Ind5@assays$RNA@scale.data

Ind6 <- subset(Ind6, cells = colnames(Ind6)[colnames(Ind6) %in% Cell_barcodes])
Ind6 <- NormalizeData(Ind6)
Ind6 <- ScaleData(Ind6, features=rownames(Ind6))
matInd6 <- Ind6@assays$RNA@scale.data

Ind7 <- subset(Ind7, cells = colnames(Ind7)[colnames(Ind7) %in% Cell_barcodes])
Ind7 <- NormalizeData(Ind7)
Ind7 <- ScaleData(Ind7, features=rownames(Ind7))
matInd7 <- Ind7@assays$RNA@scale.data

meta_Ind4 <- Ind4@meta.data
meta_Ind5 <- Ind5@meta.data
meta_Ind6 <- Ind6@meta.data
meta_Ind7 <- Ind7@meta.data

remove(Ind4, Ind5, Ind6, Ind7)
gc();gc()

### GSVA
Ind4_gsvaResult <- gsva(matInd4, Curated_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
Ind4_gsvaResult <- as.data.frame(t(Ind4_gsvaResult))
meta_Ind4 <- meta_Ind4[row.names(Ind4_gsvaResult),]
Ind4_gsvaResult_meta <- cbind(Ind4_gsvaResult, meta_Ind4)


Ind5_gsvaResult <- gsva(matInd5, Curated_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
Ind5_gsvaResult <- as.data.frame(t(Ind5_gsvaResult))
meta_Ind5 <- meta_Ind5[row.names(Ind5_gsvaResult),]
Ind5_gsvaResult_meta <- cbind(Ind5_gsvaResult, meta_Ind5)


Ind6_gsvaResult <- gsva(matInd6, Curated_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
Ind6_gsvaResult <- as.data.frame(t(Ind6_gsvaResult))
meta_Ind6 <- meta_Ind6[row.names(Ind6_gsvaResult),]
Ind6_gsvaResult_meta <- cbind(Ind6_gsvaResult, meta_Ind6)


Ind7_gsvaResult <- gsva(matInd7, Curated_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
Ind7_gsvaResult <- as.data.frame(t(Ind7_gsvaResult))
meta_Ind7 <- meta_Ind7[row.names(Ind7_gsvaResult),]
Ind7_gsvaResult_meta <- cbind(Ind7_gsvaResult, meta_Ind7)

write.csv(Ind4_gsvaResult_meta, "...zenodo/GSVA/Human/Ind4_4gene_sets_res.csv")
write.csv(Ind5_gsvaResult_meta, "...zenodo/GSVA/Human/Ind5_4gene_sets_res.csv")
write.csv(Ind6_gsvaResult_meta, "...zenodo/GSVA/Human/Ind6_4gene_sets_res.csv")
write.csv(Ind7_gsvaResult_meta, "...zenodo/GSVA/Human/Ind7_4gene_sets_res.csv")

###
human_res <- rbind(Ind4_gsvaResult_meta, Ind5_gsvaResult_meta, Ind6_gsvaResult_meta, Ind7_gsvaResult_meta)
write.csv(human_res, "...zenodo/GSVA/Human/Normal_breast_4gene_sets_res.csv")



##########################################################################
############ GSVA analysis for gene list performance evaluation ##########
##########################################################################
# Data_prep
m_df = msigdbr(species = "Homo sapiens")
GeneSets <- split(x = m_df$gene_symbol, f = m_df$gs_name)

#
# Data_prep
Ind4 <- readRDS("...zenodo/Human_normal_breast_data/Ind4/Ind4_cleaned.rds")
Ind5 <- readRDS("...zenodo/Human_normal_breast_data/Ind5/Ind5_cleaned.rds")
Ind6 <- readRDS("...zenodo/Human_normal_breast_data/Ind6/Ind6_cleaned.rds")
Ind7 <- readRDS("...zenodo/Human_normal_breast_data/Ind7/Ind7_cleaned.rds")
Cell_barcodes <- readRDS("...zenodo/STREAM/Human_cells_STREAM.rds")

#
Ind4 <- NormalizeData(Ind4)
Ind4 <- ScaleData(Ind4, features=rownames(Ind4))
matInd4 <- Ind4@assays$RNA@scale.data

Ind5 <- NormalizeData(Ind5)
Ind5 <- ScaleData(Ind5, features=rownames(Ind5))
matInd5 <- Ind5@assays$RNA@scale.data

Ind6 <- NormalizeData(Ind6)
Ind6 <- ScaleData(Ind6, features=rownames(Ind6))
matInd6 <- Ind6@assays$RNA@scale.data

Ind7 <- NormalizeData(Ind7)
Ind7 <- ScaleData(Ind7, features=rownames(Ind7))
matInd7 <- Ind7@assays$RNA@scale.data

matInd4 <- matInd4[,colnames(matInd4) %in% Cell_barcodes ]
matInd5 <- matInd5[,colnames(matInd5) %in% Cell_barcodes ]
matInd6 <- matInd6[,colnames(matInd6) %in% Cell_barcodes ]
matInd7 <- matInd7[,colnames(matInd7) %in% Cell_barcodes ]


remove(Ind5, Ind6, Ind4, Ind7, Cell_barcodes)
gc();gc()


### Run ####
Ind4_gsvaResult <- gsva(matInd4, GeneSets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind4_gsvaResult, "...zenodo/GSVA/Human/Ind4_GSVA.csv")

Ind5_gsvaResult <- gsva(matInd5, GeneSets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind5_gsvaResult, "...zenodo/GSVA/Human/Ind5_GSVA.csv")

Ind6_gsvaResult <- gsva(matInd6, GeneSets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind6_gsvaResult, "...zenodo/GSVA/Human/Ind6_GSVA.csv")

Ind7_gsvaResult <- gsva(matInd7, GeneSets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
write.csv(Ind7_gsvaResult, "...zenodo/GSVA/Human/Ind7_GSVA.csv")



##########################################################################
############ Curated gene sets; Performance evaluation ###################
##########################################################################
meta <- read.csv("...zenodo/STREAM/Human_all_output/metadata_modified.csv",
                 row.names = 1)
Cell_barcodes <- readRDS("...zenodo/STREAM/Human_cells_STREAM.rds")


Cytotrace <- read.csv("...zenodo/CytoTRACE/Human_CytoTRACE_score.csv",
                      row.names = 1)

### Ind4
Ind4_res <- read.csv("...zenodo/GSVA/Human/Ind4_4gene_sets_res.csv",
                     row.names=1)
Ind4_res <- Ind4_res[row.names(Ind4_res) %in% Cell_barcodes, c(1:4, 6:8)]
Ind4_res2 <- read.csv("...zenodo/GSVA/Human/Ind4_GSVA.csv",
                      row.names=1)
Ind4_res2 <- t(Ind4_res2)
Ind4_res2 <- Ind4_res2[row.names(Ind4_res),]

summary(row.names(Ind4_res) == row.names(Ind4_res2))

Ind4_meta <- meta[row.names(Ind4_res),7:10]

#
Ind4_matrix <- cbind(Ind4_meta, Ind4_res, Ind4_res2)

cor_Ind4_S3 <- cor(Ind4_matrix$S3_pseudotime, Ind4_matrix[,5:length(colnames(Ind4_matrix))], method = "s")
cor_Ind4_S4 <- cor(Ind4_matrix$S4_pseudotime, Ind4_matrix[,5:length(colnames(Ind4_matrix))], method = "s")
cor_Ind4_S2 <- cor(Ind4_matrix$S2_pseudotime, Ind4_matrix[,5:length(colnames(Ind4_matrix))], method = "s")
cor_Ind4_S1 <- cor(Ind4_matrix$S1_pseudotime, Ind4_matrix[,5:length(colnames(Ind4_matrix))], method = "s")

cor_Ind4_pseudotime <- rbind(cor_Ind4_S3, cor_Ind4_S4, cor_Ind4_S2, cor_Ind4_S1)
row.names(cor_Ind4_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")


Ind4_cytotrace <- Cytotrace[row.names(Cytotrace) %in% row.names(meta)[meta$label=="Ind4"], ]
meta_Ind4_cytotrace <- meta[row.names(Ind4_cytotrace),7:10]
Ind4_cytotrace_matrix <- cbind(meta_Ind4_cytotrace, Ind4_cytotrace)
cor_Ind4_cytotrace_S3 <- cor(Ind4_cytotrace_matrix$S3_pseudotime, Ind4_cytotrace_matrix[,5:length(colnames(Ind4_cytotrace_matrix))], method = "s")
cor_Ind4_cytotrace_S4 <- cor(Ind4_cytotrace_matrix$S4_pseudotime, Ind4_cytotrace_matrix[,5:length(colnames(Ind4_cytotrace_matrix))], method = "s")
cor_Ind4_cytotrace_S2 <- cor(Ind4_cytotrace_matrix$S2_pseudotime, Ind4_cytotrace_matrix[,5:length(colnames(Ind4_cytotrace_matrix))], method = "s")
cor_Ind4_cytotrace_S1 <- cor(Ind4_cytotrace_matrix$S1_pseudotime, Ind4_cytotrace_matrix[,5:length(colnames(Ind4_cytotrace_matrix))], method = "s")

cor_Ind4_cytotrace_pseudotime <- rbind(cor_Ind4_cytotrace_S3, cor_Ind4_cytotrace_S4, cor_Ind4_cytotrace_S2, cor_Ind4_cytotrace_S1)
row.names(cor_Ind4_cytotrace_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")

cor_Ind4_pseudotime <- cbind(cor_Ind4_cytotrace_pseudotime, cor_Ind4_pseudotime)

remove(cor_Ind4_cytotrace_pseudotime, cor_Ind4_cytotrace_S3, cor_Ind4_cytotrace_S4, cor_Ind4_cytotrace_S2, cor_Ind4_cytotrace_S1,
       Ind4_cytotrace_matrix, meta_Ind4_cytotrace, Ind4_cytotrace, cor_Ind4_S1, cor_Ind4_S2, cor_Ind4_S4, cor_Ind4_S3,
       Ind4_matrix, Ind4_meta, Ind4_res, Ind4_res2)
gc();gc()



### Ind5
Ind5_res <- read.csv("...zenodo/GSVA/Human/Ind5_4gene_sets_res.csv",
                     row.names=1)
Ind5_res <- Ind5_res[row.names(Ind5_res) %in% Cell_barcodes, c(1:4, 6:8)]
Ind5_res2 <- read.csv("...zenodo/GSVA/Human/Ind5_GSVA.csv",
                      row.names=1)
Ind5_res2 <- t(Ind5_res2)
Ind5_res2 <- Ind5_res2[row.names(Ind5_res),]

summary(row.names(Ind5_res) == row.names(Ind5_res2))

Ind5_meta <- meta[row.names(Ind5_res),7:10]

#
Ind5_matrix <- cbind(Ind5_meta, Ind5_res, Ind5_res2)

cor_Ind5_S3 <- cor(Ind5_matrix$S3_pseudotime, Ind5_matrix[,5:length(colnames(Ind5_matrix))], method = "s")
cor_Ind5_S4 <- cor(Ind5_matrix$S4_pseudotime, Ind5_matrix[,5:length(colnames(Ind5_matrix))], method = "s")
cor_Ind5_S2 <- cor(Ind5_matrix$S2_pseudotime, Ind5_matrix[,5:length(colnames(Ind5_matrix))], method = "s")
cor_Ind5_S1 <- cor(Ind5_matrix$S1_pseudotime, Ind5_matrix[,5:length(colnames(Ind5_matrix))], method = "s")

cor_Ind5_pseudotime <- rbind(cor_Ind5_S3, cor_Ind5_S4, cor_Ind5_S2, cor_Ind5_S1)
row.names(cor_Ind5_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")


Ind5_cytotrace <- Cytotrace[row.names(Cytotrace) %in% row.names(meta)[meta$label=="Ind5"], ]
meta_Ind5_cytotrace <- meta[row.names(Ind5_cytotrace),7:10]
Ind5_cytotrace_matrix <- cbind(meta_Ind5_cytotrace, Ind5_cytotrace)
cor_Ind5_cytotrace_S3 <- cor(Ind5_cytotrace_matrix$S3_pseudotime, Ind5_cytotrace_matrix[,5:length(colnames(Ind5_cytotrace_matrix))], method = "s")
cor_Ind5_cytotrace_S4 <- cor(Ind5_cytotrace_matrix$S4_pseudotime, Ind5_cytotrace_matrix[,5:length(colnames(Ind5_cytotrace_matrix))], method = "s")
cor_Ind5_cytotrace_S2 <- cor(Ind5_cytotrace_matrix$S2_pseudotime, Ind5_cytotrace_matrix[,5:length(colnames(Ind5_cytotrace_matrix))], method = "s")
cor_Ind5_cytotrace_S1 <- cor(Ind5_cytotrace_matrix$S1_pseudotime, Ind5_cytotrace_matrix[,5:length(colnames(Ind5_cytotrace_matrix))], method = "s")

cor_Ind5_cytotrace_pseudotime <- rbind(cor_Ind5_cytotrace_S3, cor_Ind5_cytotrace_S4, cor_Ind5_cytotrace_S2, cor_Ind5_cytotrace_S1)
row.names(cor_Ind5_cytotrace_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")

cor_Ind5_pseudotime <- cbind(cor_Ind5_cytotrace_pseudotime, cor_Ind5_pseudotime)

remove(cor_Ind5_cytotrace_pseudotime, cor_Ind5_cytotrace_S3, cor_Ind5_cytotrace_S4, cor_Ind5_cytotrace_S2, cor_Ind5_cytotrace_S1,
       Ind5_cytotrace_matrix, meta_Ind5_cytotrace, Ind5_cytotrace, cor_Ind5_S1, cor_Ind5_S2, cor_Ind5_S4, cor_Ind5_S3,
       Ind5_matrix, Ind5_meta, Ind5_res, Ind5_res2)
gc();gc()



### Ind6
Ind6_res <- read.csv("...zenodo/GSVA/Human/Ind6_4gene_sets_res.csv",
                     row.names=1)
Ind6_res <- Ind6_res[row.names(Ind6_res) %in% Cell_barcodes, c(1:4, 6:8)]
Ind6_res2 <- read.csv("...zenodo/GSVA/Human/Ind6_GSVA.csv",
                      row.names=1)
Ind6_res2 <- t(Ind6_res2)
Ind6_res2 <- Ind6_res2[row.names(Ind6_res),]

summary(row.names(Ind6_res) == row.names(Ind6_res2))

Ind6_meta <- meta[row.names(Ind6_res),7:10]

#
Ind6_matrix <- cbind(Ind6_meta, Ind6_res, Ind6_res2)

cor_Ind6_S3 <- cor(Ind6_matrix$S3_pseudotime, Ind6_matrix[,5:length(colnames(Ind6_matrix))], method = "s")
cor_Ind6_S4 <- cor(Ind6_matrix$S4_pseudotime, Ind6_matrix[,5:length(colnames(Ind6_matrix))], method = "s")
cor_Ind6_S2 <- cor(Ind6_matrix$S2_pseudotime, Ind6_matrix[,5:length(colnames(Ind6_matrix))], method = "s")
cor_Ind6_S1 <- cor(Ind6_matrix$S1_pseudotime, Ind6_matrix[,5:length(colnames(Ind6_matrix))], method = "s")

cor_Ind6_pseudotime <- rbind(cor_Ind6_S3, cor_Ind6_S4, cor_Ind6_S2, cor_Ind6_S1)
row.names(cor_Ind6_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")


Ind6_cytotrace <- Cytotrace[row.names(Cytotrace) %in% row.names(meta)[meta$label=="Ind6"], ]
meta_Ind6_cytotrace <- meta[row.names(Ind6_cytotrace),7:10]
Ind6_cytotrace_matrix <- cbind(meta_Ind6_cytotrace, Ind6_cytotrace)
cor_Ind6_cytotrace_S3 <- cor(Ind6_cytotrace_matrix$S3_pseudotime, Ind6_cytotrace_matrix[,5:length(colnames(Ind6_cytotrace_matrix))], method = "s")
cor_Ind6_cytotrace_S4 <- cor(Ind6_cytotrace_matrix$S4_pseudotime, Ind6_cytotrace_matrix[,5:length(colnames(Ind6_cytotrace_matrix))], method = "s")
cor_Ind6_cytotrace_S2 <- cor(Ind6_cytotrace_matrix$S2_pseudotime, Ind6_cytotrace_matrix[,5:length(colnames(Ind6_cytotrace_matrix))], method = "s")
cor_Ind6_cytotrace_S1 <- cor(Ind6_cytotrace_matrix$S1_pseudotime, Ind6_cytotrace_matrix[,5:length(colnames(Ind6_cytotrace_matrix))], method = "s")

cor_Ind6_cytotrace_pseudotime <- rbind(cor_Ind6_cytotrace_S3, cor_Ind6_cytotrace_S4, cor_Ind6_cytotrace_S2, cor_Ind6_cytotrace_S1)
row.names(cor_Ind6_cytotrace_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")

cor_Ind6_pseudotime <- cbind(cor_Ind6_cytotrace_pseudotime, cor_Ind6_pseudotime)

remove(cor_Ind6_cytotrace_pseudotime, cor_Ind6_cytotrace_S3, cor_Ind6_cytotrace_S4, cor_Ind6_cytotrace_S2, cor_Ind6_cytotrace_S1,
       Ind6_cytotrace_matrix, meta_Ind6_cytotrace, Ind6_cytotrace, cor_Ind6_S1, cor_Ind6_S2, cor_Ind6_S4, cor_Ind6_S3,
       Ind6_matrix, Ind6_meta, Ind6_res, Ind6_res2)
gc();gc()



### Ind7
Ind7_res <- read.csv("...zenodo/GSVA/Human/Ind7_4gene_sets_res.csv",
                     row.names=1)
Ind7_res <- Ind7_res[row.names(Ind7_res) %in% Cell_barcodes, c(1:4, 6:8)]
Ind7_res2 <- read.csv("...zenodo/GSVA/Human/Ind7_GSVA.csv",
                      row.names=1)
Ind7_res2 <- t(Ind7_res2)
Ind7_res2 <- Ind7_res2[row.names(Ind7_res),]

summary(row.names(Ind7_res) == row.names(Ind7_res2))

Ind7_meta <- meta[row.names(Ind7_res),7:10]

#
Ind7_matrix <- cbind(Ind7_meta, Ind7_res, Ind7_res2)

cor_Ind7_S3 <- cor(Ind7_matrix$S3_pseudotime, Ind7_matrix[,5:length(colnames(Ind7_matrix))], method = "s")
cor_Ind7_S4 <- cor(Ind7_matrix$S4_pseudotime, Ind7_matrix[,5:length(colnames(Ind7_matrix))], method = "s")
cor_Ind7_S2 <- cor(Ind7_matrix$S2_pseudotime, Ind7_matrix[,5:length(colnames(Ind7_matrix))], method = "s")
cor_Ind7_S1 <- cor(Ind7_matrix$S1_pseudotime, Ind7_matrix[,5:length(colnames(Ind7_matrix))], method = "s")

cor_Ind7_pseudotime <- rbind(cor_Ind7_S3, cor_Ind7_S4, cor_Ind7_S2, cor_Ind7_S1)
row.names(cor_Ind7_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")


Ind7_cytotrace <- Cytotrace[row.names(Cytotrace) %in% row.names(meta)[meta$label=="Ind7"], ]
meta_Ind7_cytotrace <- meta[row.names(Ind7_cytotrace),7:10]
Ind7_cytotrace_matrix <- cbind(meta_Ind7_cytotrace, Ind7_cytotrace)
cor_Ind7_cytotrace_S3 <- cor(Ind7_cytotrace_matrix$S3_pseudotime, Ind7_cytotrace_matrix[,5:length(colnames(Ind7_cytotrace_matrix))], method = "s")
cor_Ind7_cytotrace_S4 <- cor(Ind7_cytotrace_matrix$S4_pseudotime, Ind7_cytotrace_matrix[,5:length(colnames(Ind7_cytotrace_matrix))], method = "s")
cor_Ind7_cytotrace_S2 <- cor(Ind7_cytotrace_matrix$S2_pseudotime, Ind7_cytotrace_matrix[,5:length(colnames(Ind7_cytotrace_matrix))], method = "s")
cor_Ind7_cytotrace_S1 <- cor(Ind7_cytotrace_matrix$S1_pseudotime, Ind7_cytotrace_matrix[,5:length(colnames(Ind7_cytotrace_matrix))], method = "s")

cor_Ind7_cytotrace_pseudotime <- rbind(cor_Ind7_cytotrace_S3, cor_Ind7_cytotrace_S4, cor_Ind7_cytotrace_S2, cor_Ind7_cytotrace_S1)
row.names(cor_Ind7_cytotrace_pseudotime) <- c("cor_S3", "cor_S4", "cor_S2", "cor_S1")

cor_Ind7_pseudotime <- cbind(cor_Ind7_cytotrace_pseudotime, cor_Ind7_pseudotime)

remove(cor_Ind7_cytotrace_pseudotime, cor_Ind7_cytotrace_S3, cor_Ind7_cytotrace_S4, cor_Ind7_cytotrace_S2, cor_Ind7_cytotrace_S1,
       Ind7_cytotrace_matrix, meta_Ind7_cytotrace, Ind7_cytotrace, cor_Ind7_S1, cor_Ind7_S2, cor_Ind7_S4, cor_Ind7_S3,
       Ind7_matrix, Ind7_meta, Ind7_res, Ind7_res2)
gc();gc()


###
cor_Ind4_pseudotime <- t(cor_Ind4_pseudotime)
cor_Ind4_pseudotime <- as.data.frame(cor_Ind4_pseudotime)
cor_Ind4_pseudotime$Feature <- row.names(cor_Ind4_pseudotime)

cor_Ind5_pseudotime <- t(cor_Ind5_pseudotime)
cor_Ind5_pseudotime <- as.data.frame(cor_Ind5_pseudotime)
cor_Ind5_pseudotime$Feature <- row.names(cor_Ind5_pseudotime)

cor_Ind6_pseudotime <- t(cor_Ind6_pseudotime)
cor_Ind6_pseudotime <- as.data.frame(cor_Ind6_pseudotime)
cor_Ind6_pseudotime$Feature <- row.names(cor_Ind6_pseudotime)

cor_Ind7_pseudotime <- t(cor_Ind7_pseudotime)
cor_Ind7_pseudotime <- as.data.frame(cor_Ind7_pseudotime)
cor_Ind7_pseudotime$Feature <- row.names(cor_Ind7_pseudotime)

colnames(cor_Ind4_pseudotime)[1:4] <- paste(colnames(cor_Ind4_pseudotime)[1:4], "Ind4", sep="_")
colnames(cor_Ind5_pseudotime)[1:4] <- paste(colnames(cor_Ind5_pseudotime)[1:4], "Ind5", sep="_")
colnames(cor_Ind6_pseudotime)[1:4] <- paste(colnames(cor_Ind6_pseudotime)[1:4], "Ind6", sep="_")
colnames(cor_Ind7_pseudotime)[1:4] <- paste(colnames(cor_Ind7_pseudotime)[1:4], "Ind7", sep="_")

#
write.csv(cor_Ind4_pseudotime, "...zenodo/GSVA/Human/cor_Ind4_pseudotime.csv")
write.csv(cor_Ind5_pseudotime, "...zenodo/GSVA/Human/cor_Ind5_pseudotime.csv")
write.csv(cor_Ind6_pseudotime, "...zenodo/GSVA/Human/cor_Ind6_pseudotime.csv")
write.csv(cor_Ind7_pseudotime, "...zenodo/GSVA/Human/cor_Ind7_pseudotime.csv")

###
cor_all <- merge(cor_Ind4_pseudotime, cor_Ind5_pseudotime, by.x="Feature", by.y = "Feature")
cor_all <- merge(cor_all, cor_Ind6_pseudotime, by.x="Feature", by.y = "Feature")
cor_all <- merge(cor_all, cor_Ind7_pseudotime, by.x="Feature", by.y = "Feature")

rownames(cor_all) <- cor_all$Feature
cor_all <- cor_all[,2:17]

###
S3_mean <- -1*apply(cor_all[, grep("S3", colnames(cor_all))], 1, mean, na.rm=TRUE)
S3_rank <- rank(-1*S3_mean)

S4_mean <- -1*apply(cor_all[, grep("S4", colnames(cor_all))], 1, mean, na.rm=TRUE)
S4_rank <- rank(-1*S4_mean)

S2_mean <- -1*apply(cor_all[, grep("S2", colnames(cor_all))], 1, mean, na.rm=TRUE)
S2_rank <- rank(-1*S2_mean)

S1_mean <- -1*apply(cor_all[, grep("S1", colnames(cor_all))], 1, mean, na.rm=TRUE)
S1_rank <- rank(-1*S1_mean)

cor_all <- cbind(cor_all, S3_mean, S3_rank, S4_mean, S4_rank, S2_mean, S2_rank, S1_mean, S1_rank)

cor_all$category <- "MSigDB"
cor_all$category[rownames(cor_all) == "CytoTRACE" | rownames(cor_all) == "GCS"] <- "CytoTRACE"
cor_all$category[grep("Curated_", rownames(cor_all))] <- "Curated"
cor_all$category[rownames(cor_all) == "nFeature_RNA" |
                   rownames(cor_all) == "nCount_RNA"|
                   rownames(cor_all) == "percent.mt"] <- "Biological"  
write.csv(cor_all, "...zenodo/GSVA/Human/cor_all_pseudotime_ranked_annotated.csv")



################################################################
############### GSVA with mouse stem set #######################
################################################################
Stem_gene_sets <- readRDS("...zenodo/GSVA/Mouse/Stem_cor_genes_top1000.rds")
Stem_gene_sets <- Stem_gene_sets$Top_Stem_160

### Gene conversion
human = biomaRt::useMart("ensembl", dataset = "hsapiens_gene_ensembl")
mouse = biomaRt::useMart("ensembl", dataset = "mmusculus_gene_ensembl")

### Stem
Stem_genes.list = biomaRt::getLDS(attributes = c("hgnc_symbol"), filters = "hgnc_symbol", 
                                  values = Stem_gene_sets,
                                  mart = human, attributesL = c("mgi_symbol"), martL = mouse, uniqueRows = T)
Stem_genes.list <- Stem_genes.list[Stem_genes.list$MGI.symbol %in% Stem_gene_sets,]

Stem_gene_sets[!Stem_gene_sets %in% Stem_genes.list$MGI.symbol]
# "Tubb5"         "2810417H13Rik" "Hspe1"         "H2afz"         "Npm1"          "Tmsb10"        "Ran"           "Snrpe"        
# "Hmgb1"         "Col9a3"        "2700094K13Rik" "Rpl41"         "Rps2"          "Banf1"         "Atp5g1"        "H2afx"        
# "Sepw1"         "Rpl15"         "H2afv"         "Rplp2"         "Pebp1"    

# Manually searched in homologene
Additional_stem_genes <- c("TUBB","PCLAF", "HSPE1", "H2AFZ", "NPM1", "TMSB10", "RAN",
                           "SNRPE", "HMGB1", "COL9A3", "SELENOH", "RPL41", "RPS2", "BANF1", "ATP5G1", "H2AFX",
                           "SEPW1", "RPL15", "H2AFV", "RPLP2", "PEBP1")
Curated_stem_sets_human <- list(c(Stem_genes.list$HGNC.symbol, Additional_stem_genes))
names(Curated_stem_sets_human) <- "Curated_Stem(m2h)"
saveRDS(Curated_stem_sets_human, "...zenodo/GSVA/Human/Curated_Stem(m2h).rds")



##########################################################################
############ GSVA analysis for curated gene sets (Normal breast) #########
##########################################################################
Ind4 <- readRDS("...zenodo/Human_normal_breast_data/Ind4/Ind4_cleaned.rds")
Ind5 <- readRDS("...zenodo/Human_normal_breast_data/Ind5/Ind5_cleaned.rds")
Ind6 <- readRDS("...zenodo/Human_normal_breast_data/Ind6/Ind6_cleaned.rds")
Ind7 <- readRDS("...zenodo/Human_normal_breast_data/Ind7/Ind7_cleaned.rds")

HBC <- readRDS("...zenodo/scBRCA/HBC_tumor.rds")
HBC$orig.ident <- rep("HBC", length(colnames(HBC)))
HumanBreast <- merge(Ind4, y = c(Ind5, Ind6, Ind7, HBC), 
                     add.cell.ids = NULL, project = "HumanBreast")

meta <- read.csv("...zenodo/STREAM/Human_all_output/metadata_modified.csv",
                 row.names = 1)
Tumor <- colnames(HBC)

HumanBreast <- subset(HumanBreast, cells = c(row.names(meta), Tumor))
HumanBreast <- NormalizeData(HumanBreast)
HumanBreast <- ScaleData(HumanBreast, features=rownames(HumanBreast))
mat <- HumanBreast@assays$RNA@scale.data
meta <- HumanBreast@meta.data

remove(HBC, HumanBreast, Ind4, Ind5, Ind6, Ind7)
gc();gc()


###
Curated_stem <-  readRDS("...zenodo/GSVA/Human/Curated_Stem(m2h).rds")
Basal_gene_sets <- readRDS("...zenodo/GSVA/Human/Basal_cor_genes_top1000.rds")
Alv_gene_sets <- readRDS("...zenodo/GSVA/Human/Alv_cor_genes_top1000.rds")
Hor_gene_sets <- readRDS("...zenodo/GSVA/Human/Hor_cor_genes_top1000.rds")
Curated_gene_sets <- list(Curated_stem$`Curated_Stem(m2h)`, Basal_gene_sets$Top_Basal_1000, Alv_gene_sets$Top_Alv_500, Hor_gene_sets$Top_Hor_240)
names(Curated_gene_sets) <- c("Curated_Stem", "Curated_Basal", "Curated_Alv", "Curated_Hor")
remove(Curated_stem, Basal_gene_sets, Alv_gene_sets, Hor_gene_sets)
gc();gc()

###
HumanBreast_gsvaResult <- gsva(mat, Curated_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")
HumanBreast_gsvaResult <- as.data.frame(t(HumanBreast_gsvaResult))
HumanBreast_gsvaResult <- data.frame(HumanBreast_gsvaResult, meta)


Normal_gsvaResult <- HumanBreast_gsvaResult[HumanBreast_gsvaResult$orig.ident %in% c("Ind4", "Ind5", "Ind6", "Ind7"), ]
write.csv(Normal_gsvaResult, "...zenodo/GSVA/Human/Normal_breast_GSVA.csv")

Tumor_gsvaResult <- HumanBreast_gsvaResult[HumanBreast_gsvaResult$orig.ident %in% c("HBC"), ]
write.csv(Tumor_gsvaResult, "...zenodo/GSVA/Human/Malignant_breast_GSVA.csv")


##########################################################################
############ GSVA analysis for curated gene sets (scBRCA) ################
##########################################################################
HBC <- readRDS("...zenodo/scBRCA/HBC_tumor.rds")
HBC <- NormalizeData(HBC)
matHBC <- HBC@assays$RNA@data
matHBC <- as.matrix(matHBC)

### Gene set
Curated_stem <-  readRDS("...zenodo/GSVA/Human/Curated_Stem(m2h).rds")
Basal_gene_sets <- readRDS("...zenodo/GSVA/Human/Basal_cor_genes_top1000.rds")
Alv_gene_sets <- readRDS("...zenodo/GSVA/Human/Alv_cor_genes_top1000.rds")
Hor_gene_sets <- readRDS("...zenodo/GSVA/Human/Hor_cor_genes_top1000.rds")
Curated_gene_sets <- list(Curated_stem$`Curated_Stem(m2h)`, Basal_gene_sets$Top_Basal_1000, Alv_gene_sets$Top_Alv_500, Hor_gene_sets$Top_Hor_240)
names(Curated_gene_sets) <- c("Curated_Stem", "Curated_Basal", "Curated_Alv", "Curated_Hor")
remove(Curated_stem, Basal_gene_sets, Alv_gene_sets, Hor_gene_sets)
gc();gc()


### Run ####
HBC_GSVA_norm_individual_m2hResult <- gsva(matHBC, Curated_gene_sets, verbose=TRUE, kcdf="Gaussian", method="ssgsea")


### Construct
GSVA_res <- t(HBC_GSVA_norm_individual_m2hResult)
meta <- HBC@meta.data
GSVA_res <- data.frame(GSVA_res, meta)
write.csv(GSVA_res, "...zenodo/GSVA/Human/HBC_GSVA.csv")