# Supplementary figure 1



########################################################################
###### Environment #####################################################
########################################################################
## Package
lib <- readRDS("...zenodo/Others/library.rds")
for(i in 1: length(lib)){
  library(lib[i], character.only = T)
}

## Palette
col.std <- wes_palette("IsleofDogs1", 5)
col.str <- wes_palette("Darjeeling2", 3)
col.stg <- c(wes_palette("GrandBudapest1", 4),wes_palette("GrandBudapest2", 4))
col.clst <- c("#FDBF6F","#FF7F00", "#B2DF8A", "#33A02C",  "#FB9A99", "#E31A1C")  
col.human <- c("#FF7F00", "#33A02C", "#E31A1C")
pam50.col <- c('#7fc97f','#beaed4','#fdc086','#ffff99','#386cb0')

## Function
range01 <- function(x){(x-min(x))/(max(x)-min(x))}



####################################################################
################ SFig.1F ###########################################
####################################################################
df <- read.csv("...zenodo/Whole_mount/Whole_mount_summary.csv")
param <- colnames(df)[3:13]
param
levels(df$Group)
df$Group <- factor(df$Group, levels = c("OVX", "OVX_E2", "OVX_E2_PBDE", "OVX_E2_P4", "OVX_E2_P4_PBDE"))

df <- df[!df$Sample_number %in% c(203, 247),]
df$Complexity <- df$Duct_Length * df$Branching_Points
df$Group2 <- gsub("_PBDE", "", df$Group)
df$Group2 <- factor(df$Group2, levels = c("OVX", "OVX_E2", "OVX_E2_P4"))


my_comparisons <- list( c("OVX", "OVX_E2"), c("OVX", "OVX_E2_P4"), c("OVX_E2", "OVX_E2_P4"),
                        c("OVX_E2", "OVX_E2_PBDE"), c("OVX_E2_P4", "OVX_E2_P4_PBDE"))
my_comparisons2 <- list( c("OVX", "OVX_E2"), c("OVX", "OVX_E2_P4"), c("OVX_E2", "OVX_E2_P4"))

sub <- df[!df$Group=="OVX",]
my_comparisons3 <- list(c("OVX_E2", "OVX_E2_PBDE"), c("OVX_E2_P4", "OVX_E2_P4_PBDE"))
col = get_palette(palette = "default", 3)

p1 <- ggboxplot(df, x = "Group2", y = param[7],
                color = "Group2", add = "jitter",
                outlier.shape = NA)+
  stat_compare_means(comparisons = my_comparisons2)+
  theme(plot.title = element_text(size=18, face="bold"),
        axis.text.y =element_text(size=12),
        axis.text.x =element_text(size=12, angle = 45, hjust = 1),
        axis.title=element_text(size=14,face="bold"))+
  NoLegend()+
  xlab("")+
  ylab("Total number")+
  ggtitle("TEB-L count")+
  ylim(0, 500)

p2 <- ggboxplot(sub, x = "Group", y = param[7],
                color = "Group", add = "jitter", fill = "Group")+
  stat_compare_means(comparisons = my_comparisons3, label = "p.signif")+
  theme(plot.title = element_text(size=18, face="bold"),
        axis.text.y =element_text(size=12),
        axis.text.x =element_text(size=12, angle = 45, hjust = 1),
        axis.title=element_text(size=14,face="bold"))+
  NoLegend()+
  scale_color_manual(values = c(col[2], col[2], col[3], col[3]))+
  scale_fill_manual(values = c("white", "lightgrey","white", "lightgrey"))+
  xlab("")+
  ylab("")+
  ylim(0, 500)

SFig1F_1 <- plot_grid(p1, p2, align='hv')


p1 <- ggboxplot(df, x = "Group2", y = param[2],
                color = "Group2", add = "jitter",
                outlier.shape = NA)+
  stat_compare_means(comparisons = my_comparisons2)+
  theme(plot.title = element_text(size=18, face="bold"),
        axis.text.y =element_text(size=12),
        axis.text.x =element_text(size=12, angle = 45, hjust = 1),
        axis.title=element_text(size=14,face="bold"))+
  NoLegend()+
  xlab("")+
  ylab("Total number")+
  ggtitle("Branching points")+
  ylim(200,1400)

p2 <- ggboxplot(sub, x = "Group", y = param[2],
                color = "Group", add = "jitter", fill = "Group")+
  stat_compare_means(comparisons = my_comparisons3, label = "p.signif")+
  theme(plot.title = element_text(size=18, face="bold"),
        axis.text.y =element_text(size=12),
        axis.text.x =element_text(size=12, angle = 45, hjust = 1),
        axis.title=element_text(size=14,face="bold"))+
  NoLegend()+
  scale_color_manual(values = c(col[2], col[2], col[3], col[3]))+
  scale_fill_manual(values = c("white", "lightgrey","white", "lightgrey"))+
  xlab("")+
  ylab("")+
  ylim(200,1400)

SFig1F_2 <- plot_grid(p1, p2, align='hv')


p1 <- ggboxplot(df, x = "Group2", y = param[1],
                color = "Group2", add = "jitter",
                outlier.shape = NA)+
  stat_compare_means(comparisons = my_comparisons2)+
  theme(plot.title = element_text(size=18, face="bold"),
        axis.text.y =element_text(size=12),
        axis.text.x =element_text(size=12, angle = 45, hjust = 1),
        axis.title=element_text(size=14,face="bold"))+
  NoLegend()+
  xlab("")+
  ylab("Total length (AU)")+
  ggtitle("Duct length")+
  ylim(50000, 115000)

p2 <- ggboxplot(sub, x = "Group", y = param[1],
                color = "Group", add = "jitter", fill = "Group")+
  stat_compare_means(comparisons = my_comparisons3, label = "p.signif")+
  theme(plot.title = element_text(size=18, face="bold"),
        axis.text.y =element_text(size=12),
        axis.text.x =element_text(size=12, angle = 45, hjust = 1),
        axis.title=element_text(size=14,face="bold"))+
  NoLegend()+
  scale_color_manual(values = c(col[2], col[2], col[3], col[3]))+
  scale_fill_manual(values = c("white", "lightgrey","white", "lightgrey"))+
  xlab("")+
  ylab("")+
  ylim(50000, 115000)

SFig1F_3 <- plot_grid(p1, p2, align='hv')